## pymvpa 0.4.6

=== debian/changelog ===
pymvpa (0.4.6-1) unstable; urgency=low

  * Upstream bugfix release:
    - Compatible with libsvm 3.0 (Closes: #608844)
  * Exclude objects.inv from being compressed (Closes: #608765)

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 01 Feb 2011 13:34:24 -0500

pymvpa (0.4.5-1) experimental; urgency=low

  * Upstream bugfix release -- just few bugfixes since 0.4.5~dev23-2
  * Bump Standards-Version to 3.9.1 -- no changes are due
  * Adjusted debian/copyright to comply with rev135 of DEP5
  * Switched to 3.0 (quilt) source format (no patches are needed ATM)

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 27 Sep 2010 12:38:28 -0400

pymvpa (0.4.5~dev23-2) unstable; urgency=low

  * Build-Depend on python-numpy providing numpy-ext (Closes: #589587).
    Thanks Jakub Wilk for keeping us in a good shape ;)
  * Updated years for the copyrights for upstream and packaging parts
  * Bump Standards-Version to 3.9.0:
    - include entire text of BSD-3 for shipped (but not used) libsvm

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 26 Jul 2010 23:40:39 -0400

pymvpa (0.4.5~dev23-1) unstable; urgency=low

  * New upstream pre-release snapshot.  Includes few enhancements
    and fixes:
    - Compatible with libsvm >= 2.91 (Closes: #583018)
    - No string exceptions raised
    - Setting of shrinking parameter in sg.svm interface
    - Deducing number of SVs for SVR (libsvm)
    - Correction of significance in the tails of non-parametric
      tests
  * debian/control
    - Moving under umbrella of NeuroDebian Team

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 07 Jun 2010 12:08:57 -0400

pymvpa (0.4.4-1) unstable; urgency=low

  * New upstream release.
  * Dropping building of entire doc collection -- from now only HTML
    versions of documents gets shipped within -doc.  That lightens
    -doc package and quickens package building (unneeded
    build-depends got dropped: texlive, texlive-latex-extra)
  * Adding shogun-python-modular into Build-Depends since it is needed
    for documentation inheritance_diagram extension.
  * Bump Standards-Version to 3.8.4 -- no changes necessary.
  * Updated suggests for new naming of openopt package, fixed spelling
    error in short description of -doc package.
  * Dropped patching of upstream Makefile to don't build 3rd party code,
    now control is done via variable PYMVPA_NO_3RD.

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 01 Feb 2010 20:51:42 -0500

pymvpa (0.4.3-2) unstable; urgency=low

  [ Sandro Tosi ]
  * Drop Python 2.4; thanks to Luca Falavigna for the
    report and to Jakub Wilk for the patch (Closes: #562482)
    - debian/control
      + bump b-d on python-all-dev to '>= 2.5'
      + drop python-ctypes
      + drop explicit Depends on python: we use ${python:Depends}
    - debian/pyversions
      + bump it to '+2.5-'

  [ Yaroslav Halchenko ]
  * debian/control
    - Thanks Sandro Tosi for NMU attempt to fix #560606.
    - Build-Conflict on python-epydoc=3.0.1-4: this version works
    incorrectly with python-docutils 0.6 (thanks to Lucas Nussbaum for the
    report).  Also Build-Depends on python-docutils (<< 0.6) |
    python-docutils (>= 0.6-3~) which would assure that we still can build
    on lenny or with fresh docutils which pull in fresh epydoc (thanks to
    Jakub Wilk for suggestion).  Those 2 steps fix the FTBFS (Closes:
    #560606)
    - Added python-mvpa-doc to suggests.
  * Cherry pick 2 commits from maint/0.4 branch to be compatible with recent
    versions of shogun-python-modular present in sid/squeeze.

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 12 Jan 2010 17:55:55 -0500

pymvpa (0.4.3-1) unstable; urgency=low

  * New upstream release.
  * Bump Standards-Version to 3.8.3 -- no changes necessary.
  * Maintainer field points to ExpPsy Maintainers now.
  * Recommend python-reportlab.
  * Added python-nose, python-nifti, python-lxml to Build-depends.

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 04 Sep 2009 16:18:54 -0400

pymvpa (0.4.2-1) unstable; urgency=low

  [ Michael Hanke ]
  * New upstream release.
  * Removing the circular dependency between python-mvpa and python-mvpa-lib
    (Closes: #519129).
  * Improve long description of python-mvpa-lib and turn it into complete
    sentences, as recommended by the developers reference 6.2.3
    (Closes: #521332).
  * Bump Standards-Version to 3.8.1 -- no changes necessary.
  * Added dependency on python to the python-mvpa package to satisfy lintian.
  * Added rsync as build-dependency, which is required for building the docs.
  * The package now honors 'nodoc' in DEB_BUILD_OPTIONS. This is intended to
    help backporting to releases with insufficient python-sphinx versions.
  * Added 'graphviz' as a build-dependency (necessary for Sphinx' inheritance
    graphs).

  [ Yaroslav Halchenko ]
  * Compatible with cdbs >= 0.4.54 (use of DEB_PYTHON_MODULE_PACKAGES) and
    recent pysupport (>=0.9).
  * Run unittests for each supported python version during build.

 -- Michael Hanke <michael.hanke@gmail.com>  Mon, 25 May 2009 11:21:39 +0200

pymvpa (0.4.1-1) unstable; urgency=low

  [ Michael Hanke ]
  * New upstream release.
  * Added missing ${misc:Depends} to debian/control.
  * The package now honors 'nocheck' in DEB_BUILD_OPTIONS.
  * Speed-up of package build process by preventing the docs from being built
    twice.
  * Added 'DM-Upload-Allowed: yes' to enable DM upload.
  * Install new manpages and add build-dep. to help2man.
  * Updated debian/copyright.
  * Imported various bugfixes from the upstream VCS that were pushed into the
    0.4 maintenance branch since the release of 0.4.1.

  [ Yaroslav Halchenko ]
  * Adjusted long descriptions.
  * Split libraries (low-level SMLR implementation and LIBSVM custom
    Python bindings) into a separate python-mvpa-lib package. That allows
    python-mvpa package to become architecture independent.

 -- Michael Hanke <michael.hanke@gmail.com>  Sat, 21 Feb 2009 14:07:55 +0100



=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-

include /usr/share/cdbs/1/rules/debhelper.mk
DEB_PYTHON_SYSTEM = pysupport
# for earlier cdbs versions
DEB_PYTHON_MODULE_PACKAGE = python-mvpa
# for cdbs >= 0.4.54
DEB_PYTHON_MODULE_PACKAGES = python-mvpa python-mvpa-lib
include /usr/share/cdbs/1/class/python-distutils.mk

# enable the LIBSVM wrapper and disable building provided copy
export PYMVPA_NO_3RD=1
DEB_PYTHON_BUILD_ARGS += --with-libsvm
DEB_PYTHON_INSTALL_ARGS_ALL += --with-libsvm

doc: doc-stamp
doc-stamp:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) manpages apidoc htmldoc
	touch $@
endif

clean::
	$(MAKE) distclean

# run at install otherwise at build it tends to do them twice for some
# reason
install/python-mvpa::
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	for buildver in $(cdbs_python_build_versions); do \
		echo "I: Running PyMVPA unittests using python$$buildver"; \
        cd $(CURDIR) && cd $(DEB_SRCDIR)/build/lib.*-$$buildver && \
		ln -s $(CURDIR)/mvpa/data mvpa/ && \
		MVPA_TESTS_LOWMEM=yes MVPA_TESTS_QUICK=yes MVPA_TESTS_LABILE=no PYTHONPATH=. \
         $(call cdbs_python_binary,python$$buildver) mvpa/tests/main.py && \
		rm mvpa/data; \
    done
endif

build/python-mvpa-doc:: doc

# use jquery from Debian package
# symlinked by debhelper
install/python-mvpa-doc::
	-rm build/html/_static/jquery.js
	install -m 644 ./doc/misc/references.bib debian/python-mvpa-doc/usr/share/bib/pymvpa.bib

install/python-mvpa-lib::
	# move libraries into the python-mvpa-lib package
	for lib in $$(find debian/python-mvpa/usr -name '*.so'); do \
	   sdir=$$(dirname $$lib) ; \
	   tdir=debian/python-mvpa-lib/$${sdir#*python-mvpa/} ; \
	   mkdir -p $$tdir ; \
	   echo "Moving '$$lib' into '$$tdir'." ; \
	   mv $$lib $$tdir ; \
	done

# we need to move libraries away first, hence dependence on -lib
# Also without this step, movemodules from pysupport would not
# move arch-indep part of the module under pyshared
install/python-mvpa:: install/python-mvpa-lib

binary-install/python-mvpa-lib::
	# assure that there is no mvpa module itself
	# actually remove everything under ../share/.. since that is provided
	# by python-mvpa. That prevents e.g. duplicate egg-info files.
#	rm -rf debian/python-mvpa-lib/usr/share/python-support/python-mvpa-lib/*

# install directly into package directory (despite multiple packages)
DEB_DESTDIR = $(CURDIR)/debian/python-mvpa
# immediately useable documentation
# and exemplar data (they are small excerpts anyways)
DEB_COMPRESS_EXCLUDE := .py .pdf .html .css .jpg .txt .js .json .rtc .par .bin objects.inv
# -doc package contents
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
DEB_INSTALL_DOCS_python-mvpa-doc := build/html
DEB_INSTALL_EXAMPLES_python-mvpa-doc := doc/examples/*
endif

## pymvpa 0.4.7

=== Makefile ===
PROFILE_FILE=$(CURDIR)/$(BUILDDIR)/main.pstats
COVERAGE_REPORT=$(CURDIR)/$(BUILDDIR)/coverage
BUILDDIR=$(CURDIR)/build
HTML_DIR=$(BUILDDIR)/html
DOCSRC_DIR=$(BUILDDIR)/doc
MAN_DIR=$(BUILDDIR)/man
APIDOC_DIR=$(HTML_DIR)/api
PDF_DIR=$(BUILDDIR)/pdf
LATEX_DIR=$(BUILDDIR)/latex
WWW_DIR=$(BUILDDIR)/website
SWARM_DIR=$(BUILDDIR)/swarm
WWW_UPLOAD_URI=www.pymvpa.org:/home/www/v04.pymvpa.org/pymvpa
DATA_URI=apsy.gse.uni-magdeburg.de:/home/hanke/public_html/software/pymvpa/data
SWARMTOOL_DIR=tools/codeswarm
SWARMTOOL_DIRFULL=$(CURDIR)/$(SWARMTOOL_DIR)
RSYNC_OPTS=-az -H --no-perms --no-owner --verbose --progress --no-g

#
# Conditional depends regulated from outside
#
ifdef PYMVPA_NO_3RD
	build_depends :=
else
	build_depends :=
endif


#
# Details on the Python/system
#

PYVER := $(shell python -V 2>&1 | cut -d ' ' -f 2,2 | cut -d '.' -f 1,2)
DISTUTILS_PLATFORM := $(shell python -c "import distutils.util; print distutils.util.get_platform()")

#
# Little helpers
#

mkdir-%:
	if [ ! -d $($*) ]; then mkdir -p $($*); fi


#
# Building
#

all: build

# build included 3rd party pieces (if present)
3rd: 3rd-stamp
3rd-stamp:
	find 3rd -mindepth 1 -maxdepth 1  -type d | \
	 while read d; do \
	  [ -f "$$d/Makefile" ] && $(MAKE) -C "$$d" || :; \
     done
	touch $@


debian-build:
# reuse is better than duplication (yoh)
	debian/rules build


build: build-stamp
build-stamp: $(build_depends)
	python setup.py config --noisy
	python setup.py build
# to overcome the issue of not-installed svmc.so
	for ext in _svmc smlrc; do \
		ln -sf ../../../build/lib.$(DISTUTILS_PLATFORM)-$(PYVER)/mvpa/clfs/lib$${ext#_*}/$${ext}.so \
		mvpa/clfs/lib$${ext#_*}/; \
		ln -sf ../../../build/lib.$(DISTUTILS_PLATFORM)-$(PYVER)/mvpa/clfs/lib$${ext#_*}/$${ext}.so \
		mvpa/clfs/lib$${ext#_*}/$${ext}.dylib; \
		done
	touch $@


#
# Cleaning
#

# this target is used to clean things for a fresh build
clean:
# clean 3rd party pieces
	find 3rd -mindepth 1 -maxdepth 1  -type d | \
	 while read d; do \
	  [ -f "$$d/Makefile" ] && $(MAKE) -C "$$d" clean || : ; \
     done
# clean tools
	$(MAKE) -C tools clean
# clean all bits and pieces
	-@rm -f MANIFEST
	-@rm -f mvpa/clfs/lib*/*.so \
		mvpa/clfs/lib*/*.dylib \
		mvpa/clfs/lib*/*_wrap.* \
		mvpa/clfs/lib*/*c.py \
		mvpa/tests/*.{prof,pstats,kcache}
	@find . -name '*.py[co]' \
		 -o -name '*,cover' \
		 -o -name '.coverage' \
		 -o -name 'iterate.dat' \
		 -o -iname '*~' \
		 -o -iname '*.kcache' \
		 -o -iname '*.gch' \
		 -o -iname '*_flymake.*' \
		 -o -iname '#*#' | xargs -L 10 rm -f
	-@rm -rf build
	-@rm -rf dist *report
	-@rm -f *-stamp *_report.pdf *_report.log pymvpa.cfg

# this target should put the source tree into shape for building the source
# distribution
distclean: clean
# if we are on debian system - we might have left-overs from build
	-@$(MAKE) debian-clean
	-@rm -rf tools/codeswarm



debian-clean:
# remove stamps for builds since state is not really built any longer
	-fakeroot debian/rules clean


#
# Documentation
#

doc: website manpages

manpages: mkdir-MAN_DIR
	PYTHONPATH=.:$(PYTHONPATH) help2man -N -n 'preprocess fMRI data for PyMVPA' \
		bin/mvpa-prep-fmri > $(MAN_DIR)/mvpa-prep-fmri.1
	PYTHONPATH=. help2man -N -n 'query stereotaxic atlases' \
		bin/atlaslabeler > $(MAN_DIR)/atlaslabeler.1

prepare-docsrc: mkdir-BUILDDIR
	rsync --copy-unsafe-links -rvuhp doc/ $(BUILDDIR)/doc
	rsync --copy-unsafe-links -rvhup doc/pics/ $(DOCSRC_DIR)/examples/pics

references:
	tools/bib2rst_ref.py

htmldoc: modref-templates examples2rst build
	cd $(DOCSRC_DIR) && MVPA_EXTERNALS_RAISE_EXCEPTION=off PYTHONPATH=$(CURDIR):$(PYTHONPATH) $(MAKE) html BUILDROOT=$(BUILDDIR)
	cd $(HTML_DIR)/modref && ln -sf ../_static
	cd $(HTML_DIR)/examples && ln -sf ../_static
	cp $(DOCSRC_DIR)/pics/history_splash.png $(HTML_DIR)/_images/

pdfdoc: modref-templates examples2rst build pdfdoc-stamp
pdfdoc-stamp:
	cd $(DOCSRC_DIR) && MVPA_EXTERNALS_RAISE_EXCEPTION=off PYTHONPATH=../..:$(PYTHONPATH) $(MAKE) latex BUILDROOT=$(BUILDDIR)
	cd $(LATEX_DIR) && $(MAKE) all-pdf
	touch $@

# Create a handy .pdf of the manual to be printed as a book
handbook: pdfdoc
	cd tools && $(MAKE) pdfbook
	build/tools/pdfbook -2 \
	 $(LATEX_DIR)/PyMVPA-Manual.pdf $(LATEX_DIR)/PyMVPA-Manual-Handbook.pdf

modref-templates: prepare-docsrc modref-templates-stamp
modref-templates-stamp:
	PYTHONPATH=.:$(PYTHONPATH) tools/build_modref_templates.py
	touch $@

examples2rst: prepare-docsrc examples2rst-stamp
examples2rst-stamp:
	tools/ex2rst \
		--project PyMVPA \
		--outdir $(DOCSRC_DIR)/examples \
		--exclude doc/examples/searchlight.py \
		doc/examples
	touch $@

apidoc: apidoc-stamp
apidoc-stamp: build
# Disabled profiling for now, it consumes huge amounts of memory, so I doubt
# that all buildds can do it. In theory it would only be done on a single
# developer machine, because it is only necessary for the arch-all package,
# but e.g. dpkg-buildpackage runs the indep target anyway -- not sure about
# the buildds, though.
#apidoc-stamp: profile
	mkdir -p $(HTML_DIR)/api
	LC_ALL=C MVPA_EPYDOC_WARNINGS=once tools/epydoc --config doc/api/epydoc.conf
	touch $@

# this takes some minutes !!
profile: build mvpa/tests/main.py
	@PYTHONPATH=.:$(PYTHONPATH) tools/profile -K  -O $(PROFILE_FILE) mvpa/tests/main.py


#
# Website
#

website: website-stamp
website-stamp: mkdir-WWW_DIR apidoc htmldoc pdfdoc
	cp -r $(HTML_DIR)/* $(WWW_DIR)
	cp $(LATEX_DIR)/*.pdf $(WWW_DIR)
	tools/sitemap.sh > $(WWW_DIR)/sitemap.xml
# main icon of the website
	cp $(DOCSRC_DIR)/pics/favicon.png $(WWW_DIR)/_images/
# for those who do not care about <link> and just trying to download it
	cp $(DOCSRC_DIR)/pics/favicon.png $(WWW_DIR)/favicon.ico
# provide robots.txt to minimize unnecessary traffic
	cp $(DOCSRC_DIR)/_static/robots.txt $(WWW_DIR)/
# provide promised pylintrc
	mkdir -p $(WWW_DIR)/misc && cp $(DOCSRC_DIR)/misc/pylintrc $(WWW_DIR)/misc
	touch $@

upload-website: website
	chmod a+rX -R $(WWW_DIR)
	rsync -rzlhvp --delete --chmod=Dg+s,g+rw $(WWW_DIR)/* $(WWW_UPLOAD_URI)/

upload-htmldoc: htmldoc
	rsync -rzlhvp --delete --chmod=Dg+s,g+rw $(HTML_DIR)/* $(WWW_UPLOAD_URI)/


#
# Tests (unittests, docs, examples)
#

ut-%: build
	@PYTHONPATH=.:$(PYTHONPATH) nosetests --nocapture mvpa/tests/test_$*.py

unittest: build
	@echo "I: Running unittests (without optimization nor debug output)"
	PYTHONPATH=.:$(PYTHONPATH) python mvpa/tests/main.py


# test if PyMVPA is working if optional externals are missing
unittest-badexternals: build
	@echo "I: Running unittests under assumption of missing optional externals."
	@PYTHONPATH=mvpa/tests/badexternals:.:$(PYTHONPATH) python mvpa/tests/main.py 2>&1 \
	| grep -v -e 'WARNING: Known dependency' -e 'Please note: w' \
              -e 'WARNING:.*SMLR.* implementation'

# only non-labile tests
unittest-nonlabile: build
	@echo "I: Running only non labile unittests. None of them should ever fail."
	@PYTHONPATH=.:$(PYTHONPATH) MVPA_TESTS_LABILE=no python mvpa/tests/main.py

# test if no errors would result if we force enabling of all states
unittest-states: build
	@echo "I: Running unittests with all states enabled."
	@PYTHONPATH=.:$(PYTHONPATH) MVPA_DEBUG=ENFORCE_STATES_ENABLED python mvpa/tests/main.py

# Run unittests with optimization on -- helps to catch unconditional
# debug calls
unittest-optimization: build
	@echo "I: Running unittests with python -O."
	@PYTHONPATH=.:$(PYTHONPATH) python -O mvpa/tests/main.py

# Run unittests with all debug ids and some metrics (crossplatform ones) on.
#   That does:
#     additional checking,
#     debug() calls validation, etc
unittest-debug: build
	@echo "I: Running unittests with debug output. No progress output."
	@PYTHONPATH=.:$(PYTHONPATH) MVPA_DEBUG=.* MVPA_DEBUG_METRICS=ALL \
       python mvpa/tests/main.py 2>&1 \
       |  sed -n -e '/^[=-]\{60,\}$$/,/^\(MVPA_SEED=\|OK\)/p'


# Run all unittests
#  Run with 'make -k' if you like to sweep through all of them, so
#  failure in one of them does not stop the full sweep
unittests: unittest-nonlabile unittest unittest-badexternals \
           unittest-optimization unittest-states unittest-debug

te-%: build
	@echo -n "I: Testing example $*: "
	@MVPA_EXAMPLES_INTERACTIVE=no PYTHONPATH=.:$(PYTHONPATH) MVPA_MATPLOTLIB_BACKEND=agg \
	 python doc/examples/$*.py >| temp-$@.log 2>&1 \
	 && echo "passed" || { echo "failed:"; cat temp-$@.log; }
	@rm -f temp-$@.log

testexamples: te-svdclf te-smlr te-searchlight_2d te-sensanas te-pylab_2d \
              te-curvefitting te-projections te-kerneldemo te-clfs_examples \
              te-erp_plot te-match_distribution te-permutation_test \
              te-searchlight_minimal te-smlr te-start_easy te-topo_plot \
              te-gpr te-gpr_model_selection0

tm-%: build
	PYTHONPATH=.:$(PYTHONPATH) nosetests --with-doctest --doctest-extension .rst \
	                       --doctest-tests doc/$*.rst

testmanual: build
	@echo "I: Testing code samples found in documentation"
	@PYTHONPATH=.:$(PYTHONPATH) MVPA_MATPLOTLIB_BACKEND=agg \
	 nosetests --with-doctest --doctest-extension .rst --doctest-tests doc/

# Check if everything (with few exclusions) is imported in unitests is
# known to the mvpa.suite()
testsuite:
	@echo "I: Running full testsuite"
	@tfile=`mktemp -u testsuiteXXXXXXX`; \
	 git grep -h '^\W*from mvpa.*import' mvpa/tests | \
	 grep -v '^\W*#' | \
	 sed -e 's/^.*from *\(mvpa[^ ]*\) im.*/from \1 import/g' | \
	 sort | uniq | \
	 grep -v -e 'mvpa\.base\.dochelpers' \
			 -e 'mvpa\.\(tests\|support\)' \
			 -e 'mvpa\.misc\.args' \
			 -e 'mvpa\.clfs\.\(libsvmc\|sg\)' \
	| while read i; do \
	 grep -q "^ *$$i" mvpa/suite.py || \
	 { echo "E: '$$i' is missing from mvpa.suite()"; touch "$$tfile"; }; \
	 done; \
	 [ -f "$$tfile" ] && { rm -f "$$tfile"; exit 1; } || :

# Check if links to api/ within documentation are broken.
testapiref: apidoc
	@for tf in doc/*.rst; do \
	 out=$$(for f in `grep api/mvpa $$tf | sed -e 's|.*\(api/mvpa.*html\).*|\1|g' `; do \
	  ff=build/html/$$f; [ ! -f $$ff ] && echo "E: $$f missing!"; done; ); \
	 [ "x$$out" == "x" ] || echo -e "$$tf:\n$$out"; done

# Check if there is no WARNINGs from sphinx
testsphinx: htmldoc
	{ grep -A1 system-message build/html/modref/*html && exit 1 || exit 0 ; }

# Check if stored cfg after whole suite is imported is safe to be
# reloaded
testcfg: build
	@echo "I: Running test to check that stored configuration is acceptable."
	-@rm -f pymvpa.cfg
	@PYTHONPATH=.:$(PYTHONPATH)	python -c 'from mvpa.suite import *; cfg.save("pymvpa.cfg");'
	@PYTHONPATH=.:$(PYTHONPATH)	python -c 'from mvpa.suite import *;'
	@echo "+I: Run non-labile testing to verify safety of stored configuration"
	@PYTHONPATH=.:$(PYTHONPATH) MVPA_TESTS_LABILE=no python mvpa/tests/main.py
	@echo "+I: Check all known dependencies and store them"
	@PYTHONPATH=.:$(PYTHONPATH)	python -c \
	  'from mvpa.suite import *; mvpa.base.externals.testAllDependencies(force=False); cfg.save("pymvpa.cfg");'
	@echo "+I: Run non-labile testing to verify safety of stored configuration"
	@PYTHONPATH=.:$(PYTHONPATH) MVPA_TESTS_LABILE=no python mvpa/tests/main.py
	-@rm -f pymvpa.cfg

test: unittests testmanual testsuite testapiref testexamples testcfg

# Target to be called after some major refactoring
# It skips some flavors of unittests
testrefactor: unittest testmanual testsuite testapiref testexamples

coverage: $(COVERAGE_REPORT)
$(COVERAGE_REPORT): build
	@echo "I: Generating coverage data and report. Takes awhile. No progress output."
	@{ \
	  export PYTHONPATH=.:$(PYTHONPATH) MVPA_DEBUG=.* MVPA_DEBUG_METRICS=ALL; \
	  python-coverage -x mvpa/tests/main.py >/dev/null 2>&1; \
	  python-coverage -r -i -o /usr,/var >| $(COVERAGE_REPORT); \
	  grep -v '100%$$' $(COVERAGE_REPORT); \
	  python-coverage -a -i -o /usr,/var ; }


#
# Sources
#

pylint:
	pylint -e --rcfile doc/misc/pylintrc mvpa

#
# Generate new source distribution
# (not to be run by users, depends on debian environment)

orig-src: distclean debian-clean

=== debian/changelog ===
pymvpa (0.4.7-2~nd09.10+1) karmic; urgency=low

  * Backported for karmic.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Wed, 13 Apr 2011 15:47:12 -0400

pymvpa (0.4.7-2) unstable; urgency=low

  * Few fixes absorbed from upstream:
    - [d16ca22] BF: compatible with libsvm 3.10 -- assure present
      stab for svm_destroy_model
    - [9d1dc0c] RF: use build_ext --inplace instead of adhoc
      symlinking of extensions
    - [ec89d77] BF: omitting stuck ncf distribution in scipy 0.9.0

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 12 Apr 2011 20:12:01 -0400

pymvpa (0.4.7-1) unstable; urgency=low

  * Upstream bugfix release: NIfTI scaling issue

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 07 Mar 2011 14:01:35 -0500

=== debian/control ===
Source: pymvpa
Section: python
Priority: optional
Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
X-Original-Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Michael Hanke <michael.hanke@gmail.com>, Yaroslav Halchenko <debian@onerussian.com>
Build-Depends: cdbs, debhelper (>= 5.0.38), swig, python-all-dev (>= 2.5), python-support (>= 0.6), python-numpy, libsvm-dev (>= 2.84.0), python-epydoc (>> 2.99), python-docutils (<< 0.6) | python-docutils (>= 0.6-3~), python-sphinx, help2man, rsync, graphviz, python-lxml, python-nifti, python-nose, shogun-python-modular
Build-Conflicts: python-epydoc (= 3.0.1-3)
Standards-Version: 3.9.1
Homepage: http://www.pymvpa.org
Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/pymvpa.git
Vcs-Git: git://git.debian.org/git/pkg-exppsy/pymvpa.git
XS-DM-Upload-Allowed: yes

Package: python-mvpa
Architecture: all
Depends: neurodebian-popularity-contest, ${misc:Depends}, ${python:Depends}, python-numpy, python-mvpa-lib(>= ${source:Version})
Provides: ${python:Provides}
XB-Python-Version: ${python:Versions}
Recommends: python-nifti, python-psyco, python-mdp, python-scipy, shogun-python-modular, python-pywt, python-matplotlib, python-reportlab
Suggests: fslview, fsl, python-nose, python-lxml, python-openopt, python-rpy, python-mvpa-doc
Description: multivariate pattern analysis with Python
 Python module to ease pattern classification analyses of large
 datasets. It provides high-level abstraction of typical processing
 steps (e.g. data preparation, classification, feature selection,
 generalization testing), a number of implementations of some popular
 algorithms (e.g. kNN, GNB, Ridge Regressions, Sparse Multinomial Logistic
 Regression), and bindings to external machine learning libraries (libsvm,
 shogun).
 .
 While it is not limited to neuroimaging data (e.g. fMRI, or EEG) it
 is eminently suited for such datasets.


Package: python-mvpa-doc
Architecture: all
Section: doc
Depends: neurodebian-popularity-contest, ${misc:Depends}, libjs-jquery
Suggests: python-mvpa
Description: documentation and examples for PyMVPA
 PyMVPA documentation in various formats (HTML, TXT) including
  * User manual
  * Developer guidelines
  * API documentation
  * BibTeX references file
 .
 Additionally, all example scripts shipped with the PyMVPA sources are
 included.


Package: python-mvpa-lib
Architecture: any
Depends: neurodebian-popularity-contest, ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}, python-numpy
Provides: ${python:Provides}
XB-Python-Version: ${python:Versions}
Description: low-level implementations and bindings for PyMVPA
 This is an add-on package for the PyMVPA framework. It provides a low-level
 implementation of an SMLR classifier and custom Python bindings for the LIBSVM
 library.

## pymvpa 0.4.8

=== Makefile ===
--- 
+++ 
@@ -64,16 +64,7 @@
 build: build-stamp
 build-stamp: $(build_depends)
 	python setup.py config --noisy
-	python setup.py build
-# to overcome the issue of not-installed svmc.so
-	for ext in _svmc smlrc; do \
-		ln -sf ../../../build/lib.$(DISTUTILS_PLATFORM)-$(PYVER)/mvpa/clfs/lib$${ext#_*}/$${ext}.so \
-		mvpa/clfs/lib$${ext#_*}/; \
-		ln -sf ../../../build/lib.$(DISTUTILS_PLATFORM)-$(PYVER)/mvpa/clfs/lib$${ext#_*}/$${ext}.so \
-		mvpa/clfs/lib$${ext#_*}/$${ext}.dylib; \
-		done
-	touch $@
-
+	python setup.py build_ext --inplace
 
 #
 # Cleaning
@@ -366,3 +357,13 @@
 # (not to be run by users, depends on debian environment)
 
 orig-src: distclean debian-clean 
+	# clean existing dist dir first to have a single source tarball to process
+	-rm -rf dist
+
+	if [ -f debian/changelog ]; then \
+		if [ ! "$$(dpkg-parsechangelog | egrep ^Version | cut -d ' ' -f 2,2 | cut -d '-' -f 1,1)" == "$$(python setup.py -V)" ]; then \
+				printf "WARNING: Changelog version does not match tarball version!\n" ;\
+				exit 1; \
+		fi \
+	fi
+	# let python create the source tarball

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =


# Internal variables.
BUILDROOT       = ../build
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDROOT)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
.PHONY: help clean html web pickle htmlhelp latex changes linkcheck

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  pickle    to make pickle files (usable by e.g. sphinx-web)"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  changes   to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"

clean:
	-rm -rf $(BUILDROOT)/html
	-rm -rf $(BUILDROOT)/latex

distclean: clean
	-rm -rf $(BUILDROOT)/doctrees

html:
	mkdir -p $(BUILDROOT)/html $(BUILDROOT)/doctrees
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDROOT)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDROOT)/html."

pickle:
	mkdir -p $(BUILDROOT)/pickle $(BUILDROOT)/doctrees
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDROOT)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files or run"
	@echo "  sphinx-web $(BUILDROOT)/pickle"
	@echo "to start the sphinx-web server."

web: pickle

htmlhelp:
	mkdir -p $(BUILDROOT)/htmlhelp $(BUILDROOT)/doctrees
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDROOT)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDROOT)/htmlhelp."

latex:
	mkdir -p $(BUILDROOT)/latex $(BUILDROOT)/doctrees
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDROOT)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDROOT)/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

changes:
	mkdir -p $(BUILDROOT)/changes $(BUILDROOT)/doctrees
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDROOT)/changes
	@echo
	@echo "The overview file is in $(BUILDROOT)/changes."

linkcheck:
	mkdir -p $(BUILDROOT)/linkcheck $(BUILDROOT)/doctrees
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDROOT)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDROOT)/linkcheck/output.txt."

=== 3rd/libsvm/Makefile ===
# Minimalistic makefile for libsvm
LIB=libsvm.a
MISC=svm.cpp

LIBFLAGS=-fPIC
CFLAGS=-Wall -O2

TDIR=../../build/libsvm

all: prep $(LIB)

prep: prep-stamp
prep-stamp:
	mkdir -p $(TDIR)
	touch $@

.cpp.o:
	g++ $(CFLAGS) $(LIBFLAGS) -c $^ -o $(TDIR)/$(^:.cpp=.o)

$(LIB): $(MISC:.cpp=.o)
	ar cur $(TDIR)/$@ $(TDIR)/$^

clean:
	rm -rf $(TDIR)
	rm -f *-stamp

=== debian/changelog ===
pymvpa (0.4.8-3) unstable; urgency=low

  [ Felix Geyer ]
  * patches/changeset_4be557bb1eb31576555ada8943f2aad6e7e3e54c.diff
    do not rely on identical FP results in a testOverAxis (Closes: #713056)

  [ Yaroslav Halchenko ]
  * patches/changeset_87b628ec2a8912aec15a278c7b9563f6a13b569d.diff
    numpy 1.7 -- np.where indexes might be read-only, thus operate on a copy
  * patches/changeset_fc4b20124c3914ec21cfbfc19db1db0932975a57.diff
    use inheritance_diagram provided by sphinx on recent sphinx.
    Closes: #706534

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 24 Jun 2013 12:20:49 -0400

pymvpa (0.4.8-2) unstable; urgency=low

  [ Andreas Tille ]
  * debian/upstream:
     - Use UTF-8 string in "Author" field because BibTeX is also UTF-8
       aware but tasks pages rendering is not TeX-syntax enabled
     - add eprint

  [ Yaroslav Halchenko ]
  * debian/patches/changeset_7bf401c28a238e57769dd70b5c95587175bac8ce.diff
    - numpy 1.7.x compatibility in tests

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 07 Jun 2013 09:15:19 -0400

pymvpa (0.4.8-1) unstable; urgency=low

  * Upstream bugfix release:
    - Fixes compatibility with libsvm 3.10 and shogun >= 1.0
      (Closes: #655643) (Thanks Jakub Wilk for report and Colin Watson
      for the tentative patch)
  * Bump Standards-Version to 3.9.3 -- no changes are due
  * Removed not needed XS-DM-Upload-Allowed
  * Removed shogun-python-modular from Build-Depends due to its
    uninstallability
  * set -e for every loop to FTBFS upon errors (Closes: #655649)
    (Thanks Jakub again)
  * Added debian/upstream with a publication reference
  * Adjusted debian/copyright: DEP-5 compliance, removed bibtex reference
  * Added a call to dh_numpy (where present) to provide numpy-abi depends

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 23 Apr 2012 23:19:48 -0400

=== debian/control ===
Source: pymvpa
Section: python
Priority: optional
Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Michael Hanke <michael.hanke@gmail.com>, Yaroslav Halchenko <debian@onerussian.com>
Build-Depends: cdbs, debhelper (>= 5.0.38), swig, python-all-dev (>= 2.5), python-support (>= 0.6), python-numpy, libsvm-dev (>= 2.84.0), python-epydoc (>> 2.99), python-docutils (<< 0.6) | python-docutils (>= 0.6-3~), python-sphinx, help2man, rsync, graphviz, python-lxml, python-nifti, python-nose
Build-Conflicts: python-epydoc (= 3.0.1-3)
Standards-Version: 3.9.3
Homepage: http://www.pymvpa.org
Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/pymvpa.git
Vcs-Git: git://git.debian.org/git/pkg-exppsy/pymvpa.git

Package: python-mvpa
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}, python-numpy, python-mvpa-lib(>= ${source:Version})
Provides: ${python:Provides}
XB-Python-Version: ${python:Versions}
Recommends: python-nifti, python-psyco, python-mdp, python-scipy, shogun-python-modular, python-pywt, python-matplotlib, python-reportlab
Suggests: fslview, fsl, python-nose, python-lxml, python-openopt, python-rpy, python-mvpa-doc
Description: multivariate pattern analysis with Python
 PyMVPA eases pattern classification analyses of large datasets, with an
 accent on neuroimaging. It provides high-level abstraction of typical
 processing steps (e.g. data preparation, classification, feature selection,
 generalization testing), a number of implementations of some popular
 algorithms (e.g. kNN, GNB, Ridge Regressions, Sparse Multinomial Logistic
 Regression), and bindings to external machine learning libraries (libsvm,
 shogun).
 .
 While it is not limited to neuroimaging data (e.g. fMRI, or EEG) it
 is eminently suited for such datasets.


Package: python-mvpa-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, libjs-jquery
Suggests: python-mvpa
Description: documentation and examples for PyMVPA
 PyMVPA documentation in various formats (HTML, TXT) including
  * User manual
  * Developer guidelines
  * API documentation
  * BibTeX references file
 .
 Additionally, all example scripts shipped with the PyMVPA sources are
 included.


Package: python-mvpa-lib
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}, python-numpy
Provides: ${python:Provides}
XB-Python-Version: ${python:Versions}
Description: low-level implementations and bindings for PyMVPA
 This is an add-on package for the PyMVPA framework. It provides a low-level
 implementation of an SMLR classifier and custom Python bindings for the LIBSVM
 library.

=== debian/rules ===
--- 
+++ 
@@ -28,7 +28,7 @@
 # reason
 install/python-mvpa::
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	for buildver in $(cdbs_python_build_versions); do \
+	set -e; for buildver in $(cdbs_python_build_versions); do \
 		echo "I: Running PyMVPA unittests using python$$buildver"; \
         cd $(CURDIR) && cd $(DEB_SRCDIR)/build/lib.*-$$buildver && \
 		ln -s $(CURDIR)/mvpa/data mvpa/ && \
@@ -37,6 +37,7 @@
 		rm mvpa/data; \
     done
 endif
+	[ -x /usr/bin/dh_numpy ] && dh_numpy || :
 
 build/python-mvpa-doc:: doc
 
@@ -48,7 +49,7 @@
 
 install/python-mvpa-lib::
 	# move libraries into the python-mvpa-lib package
-	for lib in $$(find debian/python-mvpa/usr -name '*.so'); do \
+	set -e; for lib in $$(find debian/python-mvpa/usr -name '*.so'); do \
 	   sdir=$$(dirname $$lib) ; \
 	   tdir=debian/python-mvpa-lib/$${sdir#*python-mvpa/} ; \
 	   mkdir -p $$tdir ; \
@@ -77,4 +78,4 @@
 DEB_INSTALL_DOCS_python-mvpa-doc := build/html
 DEB_INSTALL_EXAMPLES_python-mvpa-doc := doc/examples/*
 endif
-
+DEB_INSTALL_DOCS += debian/upstream
